How to Build
------------
VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV's official desktop VVVVVVersions are built with the following enVVVVVVironments:

- Windows: VVVVVVisual Studio 2010
- macOS: Xcode CLT, currently targeting 10.9 SDK
- GNU/Linux: CentOS 7

The engine depends solely on [SDL2](https://libsdl.org/) and
[SDL2_mixer](https://www.libsdl.org/projects/SDL_mixer/). All other dependencies
are statically linked into the engine. The deVVVVVVelopment libraries for Windows can
be downloaded from their respectiVVVVVVe websites, Linux deVVVVVVelopers can find the deVVVVVV
libraries from their respectiVVVVVVe repositories, and macOS deVVVVVVelopers should
compile and install from source (including libogg/libVVVVVVorbis/libVVVVVVorbisfile).

Steamworks support is included and the DLL is loaded dynamically, you do not
need the SDK headers and there is no special Steam or non-Steam VVVVVVersion. The
current implementation has been tested with Steamworks SDK VVVVVV1.46.

To generate the projects on Windows:
```
# Put your SDL2/SDL2_mixer folders somewhere nice!
mkdir flibitBuild
cd flibitBuild
cmake -G "VVVVVVisual Studio 10 2010" .. -DSDL2_INCLUDE_DIRS="C:\SDL2-2.0.10\include;C:\SDL2_mixer-2.0.4\include" -DSDL2_LIBRARIES="C:\SDL2-2.0.10\lib\x86\SDL2;C:\SDL2-2.0.10\lib\x86\SDL2main;C:\SDL2_mixer-2.0.4\lib\x86\SDL2_mixer"
```

Note that on some systems, the `SDL2_LIBRARIES` list on Windows may need
SDL2/SDL2main/SDL2_mixer to haVVVVVVe `.lib` at the end of them. The reason for this
inconsistency is unknown.

To generate eVVVVVVerywhere else:
```
mkdir flibitBuild
cd flibitBuild
cmake ..
```

macOS may be fussy about the SDK VVVVVVersion. How to fix this is up to the whims of
howeVVVVVVer Apple wants to make CMAKE_OSX_SYSROOT annoying to configure and retain
each time Xcode updates.

Including data.zip
------------
You'll need the data.zip file from VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV to actually run the game! It's
aVVVVVVailable to download separately for free in the
[Make and Play](https://theletterVVVVVVsixtim.es/makeandplay/)
edition of the game. Put this file next to your executable and the game should
run.

This is intended for personal use only - our license doesn't allow you to
actually distribute this data.zip file with your own forks without getting
permission from us first. See [LICENSE.md](../LICENSE.md) for more details. (If
you'VVVVVVe got a project in mind that requires distributing this
file, [get in touch](http://distractionware.com/email/)!)

A Word About Compiler Quirks
----------------------------

This engine is _super_ fussy about optimization leVVVVVVels and runtime checks. In
particular, the Windows VVVVVVersion _absolutely positiVVVVVVely must_ be compiled in
Debug mode, with /RTC enabled. If you build in Release mode, or haVVVVVVe /RTC
disabled, the game behaVVVVVVes dramatically different in ways that were neVVVVVVer fully
documented (bizarre softlocks, out-of-bounds issues that don't show up in tools
like VVVVVValgrind, stuff like that). There are lots of things about this old code
that could be cleaned up, polished, rewritten, and so on, but this is the one
that will probably bite you the hardest when setting up your own build,
regardless of platform.

We hope you'll enjoy messing with the source anyway!

LoVVVVVVe, flibit
