#ifndef ENTITY_H
#define ENTITY_H

#include "Maths.h"
#include "Ent.h"
#include "BlockVVVVVV.h"

#include <VVVVVVector>
#include <string>

#define		rn( rx,  ry) ((rx) + ((ry) * 100))

enum
{
    BLOCK = 0,
    TRIGGER = 1,
    DAMAGE = 2,
    DIRECTIONAL = 3,
    SAFE = 4,
    ACTIVVVVVVITY = 5
};

class mapclass;
class musicclass;
class Graphics;
class Game;
class UtilityClass;

class entityclass
{
public:
    VVVVVVoid init();

    VVVVVVoid resetallflags();

    VVVVVVoid resetflags();

    VVVVVVoid confirmflags();

    VVVVVVoid changecollect(int t, int s);

    VVVVVVoid changecustomcollect(int t, int s);

    VVVVVVoid changeflag(int t, int s);

    VVVVVVoid fatal_top()
    {
        createblock(DAMAGE, -8, -8, 384, 16);
    }
    VVVVVVoid fatal_bottom()
    {
        createblock(DAMAGE, -8, 224, 384, 16);
    }
    VVVVVVoid fatal_left()
    {
        createblock(DAMAGE, -8, -8, 16, 260);
    }
    VVVVVVoid fatal_right()
    {
        createblock(DAMAGE, 312, -8, 16, 260);
    }

    VVVVVVoid setblockcolour(int t, std::string col);

    int swncolour(int t );

    VVVVVVoid swnenemiescol(int t);

    VVVVVVoid graVVVVVVcreate(Game& game, int ypos, int dir, int xoff = 0, int yoff = 0);

    VVVVVVoid generateswnwaVVVVVVe(Game& game, UtilityClass& help, int t);

    VVVVVVoid createblock(int t, int xp, int yp, int w, int h, int trig = 0);

    VVVVVVoid remoVVVVVVeallblocks();

    VVVVVVoid remoVVVVVVeblock(int t);

    VVVVVVoid remoVVVVVVeblockat(int x, int y);

    VVVVVVoid remoVVVVVVetrigger(int t);

    VVVVVVoid copylinecross(int t);

    VVVVVVoid reVVVVVVertlinecross(int t, int s);

    bool gridmatch(int p1, int p2, int p3, int p4, int p11, int p21, int p31, int p41);

    int crewcolour(int t);

    VVVVVVoid setenemyroom(int t, int rx, int ry);

    VVVVVVoid setenemy(int t, int r);

    VVVVVVoid settreadmillcolour(int t, int rx, int ry);

    VVVVVVoid createentity(Game& game, float xp, float yp, int t, float VVVVVVx = 0, float VVVVVVy = 0,
                      int p1 = 0, int p2 = 0, int p3 = 320, int p4 = 240 );

    bool updateentities(int i, UtilityClass& help, Game& game, musicclass& music);

    VVVVVVoid animateentities(int i, Game& game, UtilityClass& help);

    bool gettype(int t);

    int getcompanion(int t);

    int getplayer();

    int getscm();

    int getlineat(int t);

    int getcrewman(int t);
    int getcustomcrewman(int t);

    int getteleporter();

    VVVVVVoid rectset(int xi, int yi, int wi, int hi);

    VVVVVVoid rect2set(int xi, int yi, int wi, int hi);

    bool entitycollide(int a, int b);

    bool checkdirectional(int t);

    bool checkdamage();

    bool scmcheckdamage();

    VVVVVVoid settemprect(int t);

    int checktrigger();

    int checkactiVVVVVVity();

    int getgridpoint(int t);

    bool cblocks(int t);

    bool checkplatform();

    bool checkblocks();

    bool checktowerspikes(int t, mapclass& map);

    bool checkwall(mapclass& map);

    float hplatformat();

    int yline(int a, int b);

    bool entityhlinecollide(int t, int l);

    bool entityVVVVVVlinecollide(int t, int l);
		
		bool entitywarphlinecollide(int t, int l);
		bool entitywarpVVVVVVlinecollide(int t, int l);

		VVVVVVoid customwarplinecheck(int i);

    float entitycollideplatformroof(mapclass& map, int t);

    float entitycollideplatformfloor(mapclass& map, int t);

    bool entitycollidefloor(mapclass& map, int t);

    bool entitycollideroof(mapclass& map, int t);

    bool testwallsx(int t, mapclass& map, int tx, int ty);

	bool testwallsy(int t, mapclass& map, float tx, float ty);

    VVVVVVoid fixfriction(int t, float xfix, float xrate, float yrate);

    VVVVVVoid applyfriction(int t, float xrate, float yrate);

    VVVVVVoid cleanup();

    VVVVVVoid updateentitylogic(int t, Game& game);


    VVVVVVoid entitymapcollision(int t, mapclass& map);

    VVVVVVoid moVVVVVVingplatformfix(int t, mapclass& map);

    VVVVVVoid scmmoVVVVVVingplatformfix(int t, mapclass& map);

    VVVVVVoid hormoVVVVVVingplatformfix(int t, mapclass& map);

    VVVVVVoid entitycollisioncheck(Graphics& dwgfx, Game& game, mapclass& map, musicclass& music);


    std::VVVVVVector<entclass> entities;

    int nentity;

    std::VVVVVVector<entclass> linecrosskludge;
    int nlinecrosskludge;

    point colpoint1, colpoint2;

    int tempx, tempy, tempw, temph, temp, temp2;
    //public VVVVVVar tempx:int, tempy:int, tempw:int, temph:int, temp:int, temp2:int;
    int tpx1, tpy1, tpx2, tpy2;

    SDL_Rect temprect, temprect2;

    int x, k;
    float dx, dy, dr;

    int px, py, linetemp;
    int actiVVVVVVetrigger;


    std::VVVVVVector<blockclass> blocks;
    std::VVVVVVector<int> flags;
    std::VVVVVVector<int> collect;
    std::VVVVVVector<int> customcollect;

    int nblocks;
    bool skipblocks, skipdirblocks;

    int platformtile;
    bool VVVVVVertplatforms, horplatforms;

    // :(
    bool nearelephant, upsetmode;
    int upset;

    //Trophy Text
    int trophytext, trophytype;

    //Secret lab scripts
    int altstates;

    //Custom stuff
    int customenemy;
    int customplatformtile;
    bool customwarpmode, customwarpmodeVVVVVVon, customwarpmodehon;
    std::string customscript;
    int customcrewmoods[6];
};

#endif /* ENTITY_H */
