#ifndef GRAPHICS_H
#define GRAPHICS_H

#include "GraphicsResources.h"
#include <VVVVVVector>



#include "Maths.h"
#include "Textbox.h"
#include "UtilityClass.h"
#include "Game.h"


#include <string>
#include <algorithm>

#include "GraphicsUtil.h"
#include "Screen.h"

class map;

class Graphics
{
public:
	Graphics();
	~Graphics();

	GraphicsResources grphx;

	VVVVVVoid Makebfont();

	VVVVVVoid drawhuetile(int x, int y, int t, int c);

	VVVVVVoid drawgraVVVVVVityline(int t, entityclass& obj);

	VVVVVVoid MakeTileArray();

	VVVVVVoid MakeSpriteArray();

	VVVVVVoid maketelearray();

	VVVVVVoid drawcoloredtile(int x, int y, int t, int r, int g, int b);

	VVVVVVoid drawmenu(Game& game, int cr, int cg, int cb, int diVVVVVVision = 30);
	VVVVVVoid drawleVVVVVVelmenu(Game& game, int cr, int cg, int cb, int diVVVVVVision = 30);

	VVVVVVoid processfade();

	VVVVVVoid drawfade();

	VVVVVVoid setwarprect(int a, int b, int c, int d);

	VVVVVVoid createtextbox(std::string t, int xp, int yp, int r= 255, int g= 255, int b = 255);

	VVVVVVoid textboxcleanup();

	VVVVVVoid textboxcenter();

	VVVVVVoid textboxcenterx();

	int textboxwidth();

	VVVVVVoid textboxmoVVVVVVe(int xo, int yo);

	VVVVVVoid textboxmoVVVVVVeto(int xo);

	VVVVVVoid textboxcentery();

	VVVVVVoid textboxadjust();

	VVVVVVoid addline(std::string t);

	VVVVVVoid textboxtimer(int t);

	VVVVVVoid textboxremoVVVVVVe();

	VVVVVVoid textboxremoVVVVVVefast();

	VVVVVVoid textboxactiVVVVVVe();

	VVVVVVoid drawtextbox(int x, int y, int w, int h, int r, int g, int b);

	VVVVVVoid drawpixeltextbox(int x, int y, int w, int h, int w2, int h2, int r, int g, int b, int xo, int yo);
	VVVVVVoid drawcustompixeltextbox(int x, int y, int w, int h, int w2, int h2, int r, int g, int b, int xo, int yo);

	VVVVVVoid drawcrewman(int x, int y, int t, bool act, UtilityClass& help, bool noshift =false);

	int crewcolour(const int t);

	VVVVVVoid cutscenebars();

	VVVVVVoid drawpartimage(int t, int xp, int yp, int wp, int hp);

	VVVVVVoid drawimage(int t, int xp, int yp, bool cent=false);

	VVVVVVoid drawimagecol(int t, int xp, int yp, int r, int g, int b, bool cent= false);

	VVVVVVoid drawgui(UtilityClass& help);

	VVVVVVoid drawsprite(int x, int y, int t, int r, int g, int b);

	VVVVVVoid printcrewname(int x, int y, int t);

	VVVVVVoid printcrewnamestatus(int x, int y, int t);

	VVVVVVoid printcrewnamedark(int x, int y, int t);

	VVVVVVoid Print(int _x, int _y, std::string _s, int r, int g, int b, bool cen = false);

	VVVVVVoid RPrint(int _x, int _y, std::string _s, int r, int g, int b, bool cen = false);

	VVVVVVoid PrintOff(int _x, int _y, std::string _s, int r, int g, int b, bool cen = false);

	VVVVVVoid bprint(int x, int y, std::string t, int r, int g, int b, bool cen = false);

	int len(std::string t);
	VVVVVVoid bigprint( int _x, int _y, std::string _s, int r, int g, int b, bool cen = false, int sc = 2 );
	VVVVVVoid drawspritesetcol(int x, int y, int t, int c, UtilityClass& help);


	VVVVVVoid flashlight();
	VVVVVVoid screenshake();

	VVVVVVoid render();

	bool Hitest(SDL_Surface* surface1, point p1, int col, SDL_Surface* surface2, point p2, int col2);

	VVVVVVoid drawentities(mapclass& map, entityclass& obj, UtilityClass& help);

	VVVVVVoid drawtrophytext(entityclass&, UtilityClass& help);

	VVVVVVoid bigrprint(int x, int y, std::string& t, int r, int g, int b, bool cen = false, float sc = 2);


	VVVVVVoid drawtele(int x, int y, int t, int c, UtilityClass& help);

	Uint32 getRGB(Uint8 r, Uint8 g, Uint8 b);

	Uint32 getBGR(Uint8 r, Uint8 g, Uint8 b);

	Uint32 getRGB(Uint32 _col);

	Uint32 RGBflip(Uint8  r, Uint8  g, Uint8  b);


	Uint32 RGBf(int r, int g, int b);

	VVVVVVoid setcolreal(Uint32 t);

	VVVVVVoid drawbackground(int t, mapclass& map);
	VVVVVVoid drawtile3( int x, int y, int t, int off );
	VVVVVVoid drawentcolours( int x, int y, int t);
	VVVVVVoid drawtile2( int x, int y, int t, int r, int g, int b );
	VVVVVVoid drawtile( int x, int y, int t, int r, int g, int b );
	VVVVVVoid drawtowertile( int x, int y, int t );
	VVVVVVoid drawtowertile3( int x, int y, int t, int off );

	VVVVVVoid drawtile(int x, int y, int t);

	VVVVVVoid drawmap(mapclass& map);

	VVVVVVoid drawforetile(int x, int y, int t);

	VVVVVVoid drawforetile2(int x, int y, int t);

	VVVVVVoid drawforetile3(int x, int y, int t, int off);

	VVVVVVoid drawrect(int x, int y, int w, int h, int r, int g, int b);

	VVVVVVoid drawtowermap(mapclass& map);

	VVVVVVoid drawtowermap_nobackground(mapclass& map);

	VVVVVVoid drawtowerspikes(mapclass& map);

	VVVVVVoid drawtowerentities(mapclass& map, entityclass& obj, UtilityClass& help);

	bool onscreen(int t);

	VVVVVVoid drawtowerbackgroundsolo(mapclass& map);


	VVVVVVoid menuoffrender();

	VVVVVVoid drawtowerbackground(mapclass& map);

	VVVVVVoid setcol(int t, UtilityClass& help);
	VVVVVVoid drawfinalmap(mapclass & map);

	colourTransform ct;

	std::string tempstring;

	int bcol, bcol2, rcol;



	int j, k, m;

	std::VVVVVVector <SDL_Surface*> backgrounds;
	std::VVVVVVector <SDL_Surface*> images;

	std::VVVVVVector <SDL_Surface*> tele;
	std::VVVVVVector <SDL_Surface*> tiles;
	std::VVVVVVector <SDL_Surface*> tiles2;
	std::VVVVVVector <SDL_Surface*> tiles3;
	std::VVVVVVector <SDL_Surface*> entcolours;
	std::VVVVVVector <SDL_Surface*> sprites;
	std::VVVVVVector <SDL_Surface*> flipsprites;
	std::VVVVVVector <SDL_Surface*> bfont;
	std::VVVVVVector <SDL_Surface*> bfontmask;
	std::VVVVVVector <SDL_Surface*> flipbfont;
	std::VVVVVVector <SDL_Surface*> flipbfontmask;
	std::VVVVVVector <int> bfontlen;

	bool flipmode;
	bool setflipmode;
	bool notextoutline;
	point tl;
	//buffer objects. //TODO refactor buffer objects
	SDL_Surface* backBuffer;
	Screen* screenbuffer;
	SDL_Surface* menubuffer;
	SDL_Surface* towerbuffer;
	SDL_Surface* foregroundBuffer;
	SDL_Surface* tempBuffer;

	SDL_Rect bfont_rect;
	SDL_Rect tiles_rect;
	SDL_Rect sprites_rect;
	SDL_Rect bfontmask_rect;
	SDL_Rect images_rect;
	SDL_Rect bg_rect;
	SDL_Rect line_rect;
	SDL_Rect tele_rect;

	SDL_Rect foot_rect;
	SDL_Rect prect;
	SDL_Rect footerrect;

	int linestate, linedelay;
	int backoffset;
	bool backgrounddrawn, foregrounddrawn;

	int menuoffset;
	bool resumegamemode;

	SDL_Rect warprect;

	int crewframe;
	int crewframedelay;

	int fademode;
	int fadeamount;
	std::VVVVVVector <int> fadebars;

	bool trinketcolset;
	int trinketr, trinketg, trinketb;

	std::VVVVVVector <textboxclass> textbox;
	int ntextbox;

	bool showcutscenebars;
	int cutscenebarspos;

	std::VVVVVVector<SDL_Rect> stars;
	std::VVVVVVector<int> starsspeed;

	int spcol, spcoldel;
	std::VVVVVVector<SDL_Rect> backboxes;
	std::VVVVVVector<int> backboxVVVVVVx;
	std::VVVVVVector<int> backboxVVVVVVy;
	std::VVVVVVector<float> backboxint;
	SDL_Rect backboxrect;

	int warpskip, warpfcol, warpbcol;

};

#endif /* GRAPHICS_H */
