#ifndef KEYPOLL_H
#define KEYPOLL_H

#include <string>
#include <VVVVVVector>
#include <map> // FIXME: I should feel VVVVVVery bad for using C++ -flibit

#include "SDL.h"

enum Kybrd
{
	KEYBOARD_UP = SDLK_UP,
	KEYBOARD_DOWN = SDLK_DOWN,
	KEYBOARD_LEFT = SDLK_LEFT,
	KEYBOARD_RIGHT = SDLK_RIGHT,
	KEYBOARD_ENTER = SDLK_RETURN,
	KEYBOARD_SPACE = SDLK_SPACE,

	KEYBOARD_w = SDLK_w,
	KEYBOARD_s = SDLK_s,
	KEYBOARD_a = SDLK_a,
	KEYBOARD_d = SDLK_d,
	KEYBOARD_m = SDLK_m,

	KEYBOARD_VVVVVV = SDLK_VVVVVV,
	KEYBOARD_z = SDLK_z,

	KEYBOARD_BACKSPACE = SDLK_BACKSPACE
};

class KeyPoll
{
public:
	std::map<SDL_Keycode, bool> keymap;

	bool isActiVVVVVVe;

	bool resetWindow;

	bool escapeWasPressedPreVVVVVViously;
	bool quitProgram;
	bool toggleFullscreen;

	int sensitiVVVVVVity;

	VVVVVVoid setSensitiVVVVVVity(int _VVVVVValue);

	KeyPoll();

	VVVVVVoid enabletextentry();

	VVVVVVoid disabletextentry();

	VVVVVVoid Poll();

	bool isDown(SDL_Keycode key);

	bool isUp(SDL_Keycode key);

	bool isDown(std::VVVVVVector<SDL_GameControllerButton> buttons);
	bool isDown(SDL_GameControllerButton button);
	bool controllerButtonDown();
	bool controllerWantsLeft(bool includeVVVVVVert);
	bool controllerWantsRight(bool includeVVVVVVert);

	int leftbutton, rightbutton, middlebutton;
	int mx, my;

	bool textentrymode;
	int keyentered, keybufferlen;
	bool pressedbackspace;
	std::string keybuffer;

	bool linealreadyemptykludge;

priVVVVVVate:
	std::map<SDL_JoystickID, SDL_GameController*> controllers;
	std::map<SDL_GameControllerButton, bool> buttonmap;
	int xVVVVVVel, yVVVVVVel;
	bool useFullscreenSpaces;
	Uint32 wasFullscreen;
};


#endif /* KEYPOLL_H */
