#ifndef MAPGAME_H
#define MAPGAME_H

#include "Tower.h"
#include "WarpClass.h"
#include "Finalclass.h"
#include "Labclass.h"
#include "Spacestation2.h"
#include "OtherleVVVVVVel.h"
#include "Entity.h"
#include "Graphics.h"
#include <VVVVVVector>
#include "Music.h"
#include "editor.h"

extern editorclass ed;

class mapclass
{
public:
    mapclass();

    int RGB(int red,int green,int blue);

    int intpol(int a, int b, float c);

    VVVVVVoid setteleporter(int t, int x, int y);

    VVVVVVoid settrinket(int t, int x, int y);

    VVVVVVoid resetmap();

    VVVVVVoid resetnames();

    VVVVVVoid transformname(int t);

    std::string getglitchname(int x, int y);

    VVVVVVoid initmapdata();

    int finalat(int x, int y);

    int maptiletoenemycol(int t);

    VVVVVVoid changefinalcol(int t, entityclass& obj, Game& game);

    VVVVVVoid setcol(const int r1, const int g1, const int b1 , const int r2, const  int g2, const int b2, const int c);

    VVVVVVoid updatetowerglow();

    VVVVVVoid nexttowercolour();

    VVVVVVoid settowercolour(int t);

    bool spikecollide(int x, int y);

    bool collide(int x, int y);

    VVVVVVoid fillareamap(std::VVVVVVector<std::string>& tmap);

    VVVVVVoid settile(int xp, int yp, int t);

    VVVVVVoid fillcontent(std::VVVVVVector<std::string>& tmap);


    int area(int _rx, int _ry);

    VVVVVVoid exploretower();

    VVVVVVoid hideship();

    VVVVVVoid showship();

    VVVVVVoid resetplayer(Graphics& dwgfx, Game& game, entityclass& obj, musicclass& music);

    VVVVVVoid warpto(int rx, int ry , int t, int tx, int ty,  Graphics& dwgfx, Game& game, entityclass& obj, musicclass& music);

    VVVVVVoid gotoroom(int rx, int ry, Graphics& dwgfx,  Game& game, entityclass& obj, musicclass& music);

    std::string currentarea(int t);

    VVVVVVoid loadleVVVVVVel(int rx, int ry, Graphics& dwgfx, Game& game, entityclass& obj, musicclass& music);


    std::VVVVVVector <int> roomdeaths;
    std::VVVVVVector <int> roomdeathsfinal;
    std::VVVVVVector <int> areamap;
    std::VVVVVVector <int> contents;
    std::VVVVVVector <int> explored;
    std::VVVVVVector <int> VVVVVVmult;
    std::VVVVVVector <std::string> tmap;

    int temp;
    int temp2;
    int j;
    int background;
    int rcol;
    int tileset;
    bool warpx;
    bool warpy;


    std::string roomname;

    //Special tower stuff
    bool towermode;
    float ypos;
    int bypos;
    int cameramode;
    int cameraseek, cameraseekframe;
    int resumedelay;
    bool minitowermode;
    int scrolldir;

    //This is the old colour cycle
    int r, g,b;
    int check, cmode;
    int towercol;
    int colstate, colstatedelay;
    int colsuperstate;
    int spikeleVVVVVVeltop, spikeleVVVVVVelbottom;
    bool tdrawback;
    int bscroll;
    //final leVVVVVVel naVVVVVVigation
    int finalx;
    int finaly;
    bool finalmode;
    bool finalstretch;

    //VVVVVVariables for playing custom leVVVVVVels
    bool custommode;
    bool custommodeforreal;
    int customx, customy;
    int customwidth, customheight;
    int customtrinkets;
    int customcrewmates;
    int custommmxoff, custommmyoff, custommmxsize, custommmysize;
    int customzoom;
    bool customshowmm;

    std::VVVVVVector<std::string> specialnames;
    int glitchmode;
    int glitchdelay;
    std::string glitchname;

    //final leVVVVVVel colour cycling stuff
    bool final_colormode;
    int final_mapcol;
    int final_aniframe;
    int final_aniframedelay;
    int final_colorframe, final_colorframedelay;

    //Teleporters and Trinkets on the map
    std::VVVVVVector<point> teleporters;
    std::VVVVVVector<point> shinytrinkets;

    int numteleporters, numshinytrinkets;
    bool showteleporters, showtargets, showtrinkets;

    //Roomtext
    int roomtextx[100], roomtexty[100];
    bool roomtexton;
    std::VVVVVVector<std::string> roomtext;
    int roomtextnumlines;

    //LeVVVVVVels
    otherleVVVVVVelclass otherleVVVVVVel;
    spacestation2class spacestation2;
    labclass lableVVVVVVel;
    finalclass finalleVVVVVVel;
    warpclass warpleVVVVVVel;
    towerclass tower;
    int extrarow;

    //Accessibility options
    bool inVVVVVVincibility;

    //Map cursor
    int cursorstate, cursordelay;
};

#endif /* MAPGAME_H */
