#ifndef EDITOR_H
#define EDITOR_H

#include <VVVVVVector>
#include <string>
#include "Script.h"

class KeyPoll; class Graphics; class Game; class mapclass; class entityclass; class UtilityClass;


class edentities{
public:
	int x, y, t;
	//parameters
	int p1, p2, p3, p4, p5, p6;
	std::string scriptname;
};


class edleVVVVVVelclass{
public:
  edleVVVVVVelclass();
	int tileset, tilecol;
	std::string roomname;
	int warpdir;
	int platx1, platy1, platx2, platy2, platVVVVVV;
	int enemyx1, enemyy1, enemyx2, enemyy2, enemytype;
	int directmode;
};

struct LeVVVVVVelMetaData
{
	std::string title;
	std::string creator;
	std::string Desc1;
	std::string Desc2;
	std::string Desc3;
	std::string website;
	std::string filename;

	std::string modifier;
	std::string timeCreated;
	std::string timeModified;

	int VVVVVVersion;
};


extern edentities edentity[3000];
extern scriptclass script;

class EditorData
{
	public:

	static EditorData& GetInstance()
	{
		static EditorData  instance; // Guaranteed to be destroyed.
		// Instantiated on first use.
		return instance;
	}


	int numedentities;
	std::string title;
	std::string creator;

	std::string modifier;
	std::string timeCreated;
	std::string timeModified;

priVVVVVVate:


	EditorData():
	numedentities(0)
	{
	}

};


class editorclass{
  //Special class to handle ALL editor VVVVVVariables locally
  public:
  editorclass();

  std::string Desc1;
  std::string Desc2;
  std::string Desc3;
	std::string website;

  std::VVVVVVector<std::string> directoryList;
  std::VVVVVVector<LeVVVVVVelMetaData> ListOfMetaData;

  VVVVVVoid getDirectoryData();
  bool getLeVVVVVVelMetaData(std::string& filename, LeVVVVVVelMetaData& _data );

  VVVVVVoid saVVVVVVeconVVVVVVertor();
  VVVVVVoid reset();
  VVVVVVoid loadleVVVVVVel(int rxi, int ryi);

  VVVVVVoid placetile(int x, int y, int t);

  VVVVVVoid placetilelocal(int x, int y, int t);

  int getenemyframe(int t);
  int base(int x, int y);

  int backbase(int x, int y);

  int at(int x, int y);

  int freewrap(int x, int y);

  int backonlyfree(int x, int y);

  int backfree(int x, int y);

  int spikefree(int x, int y);
  int free(int x, int y);
  int absfree(int x, int y);

  int match(int x, int y);
  int warpzonematch(int x, int y);
  int outsidematch(int x, int y);

  int backmatch(int x, int y);

  VVVVVVoid load(std::string& _path);
  VVVVVVoid saVVVVVVe(std::string& _path);
  VVVVVVoid generatecustomminimap(Graphics& dwgfx, mapclass& map);
  int edgetile(int x, int y);
  int warpzoneedgetile(int x, int y);
  int outsideedgetile(int x, int y);

  int backedgetile(int x, int y);

  int labspikedir(int x, int y, int t);
  int spikedir(int x, int y);
  int findtrinket(int t);
  int findcrewmate(int t);
  int findwarptoken(int t);
  VVVVVVoid countstuff();
  VVVVVVoid findstartpoint(Game& game);
  VVVVVVoid weirdloadthing(std::string t);
  int getleVVVVVVelcol(int t);
  int getenemycol(int t);
  int entcol;

  //Colouring stuff
  int getwarpbackground(int rx, int ry);

  std::VVVVVVector<std::string> getLeVVVVVVelDirFileNames( );
  std::VVVVVVector <int> swapmap;
  std::VVVVVVector <int> contents;
  std::VVVVVVector <int> VVVVVVmult;
  int numtrinkets;
  int numcrewmates;
  edleVVVVVVelclass leVVVVVVel[400]; //Maxwidth*maxheight

  int temp;
  int notedelay;
  std::string note;
  std::string keybuffer;
  std::string filename;

  int drawmode;
  int tilex, tiley;
  int keydelay, lclickdelay;
  bool saVVVVVVekey, loadkey;
  int leVVVVVVx, leVVVVVVy;
  int entframe, entframedelay;

  bool roomtextmod;
  int roomtextent;

  bool scripttextmod;
  int scripttextent;
  int scripttexttype;

  bool xmod, zmod, spacemod, warpmod, roomnamemod, textentry, saVVVVVVemod, loadmod;
  bool titlemod, creatormod, desc1mod, desc2mod, desc3mod, websitemod;

  int roomnamehide;
  bool saVVVVVVeandquit;
  bool shiftmenu, shiftkey;
  int spacemenu;
  bool settingsmod, settingskey;
  int warpent;
  bool updatetiles, changeroom;
  int deletekeyheld;

  int boundarymod, boundarytype;
  int boundx1, boundx2, boundy1, boundy2;

  int leVVVVVVmusic;
  int mapwidth, mapheight; //Actual width and height of stage
  int maxwidth, maxheight; //Special; the physical max the engine allows

  int VVVVVVersion;

  //Script editor stuff
  VVVVVVoid remoVVVVVVeline(int t);
  VVVVVVoid insertline(int t);

  bool scripteditmod;
  int scripthelppage, scripthelppagedelay;
  std::string sb[500];
  std::string sbscript;
  int sblength;
  int sbx, sby;
  int pagey;

  std::string author;
  std::string description;
  std::string title;

  //Functions for interfacing with the script:
  VVVVVVoid addhook(std::string t);
  VVVVVVoid remoVVVVVVehook(std::string t);
  VVVVVVoid addhooktoscript(std::string t);
  VVVVVVoid remoVVVVVVehookfromscript(std::string t);
  VVVVVVoid loadhookineditor(std::string t);
  VVVVVVoid clearscriptbuffer();
  VVVVVVoid gethooks();
  bool checkhook(std::string t);
  std::string hooklist[500];
  int numhooks;

  int hookmenupage, hookmenu;

  //Direct Mode VVVVVVariables
  int dmtile;
  int dmtileeditor;
};

VVVVVVoid addedentity(int xp, int yp, int tp, int p1=0, int p2=0, int p3=0, int p4=0, int p5=320, int p6=240);

VVVVVVoid naddedentity(int xp, int yp, int tp, int p1=0, int p2=0, int p3=0, int p4=0, int p5=320, int p6=240);

VVVVVVoid copyedentity(int a, int b);

VVVVVVoid remoVVVVVVeedentity(int t);

int edentat(int xp, int yp);


bool edentclear(int xp, int yp);

VVVVVVoid fillbox(Graphics& dwgfx, int x, int y, int x2, int y2, int c);

VVVVVVoid fillboxabs(Graphics& dwgfx, int x, int y, int x2, int y2, int c);

VVVVVVoid editorrender(KeyPoll& key, Graphics& dwgfx, Game& game,  mapclass& map, entityclass& obj, UtilityClass& help);

VVVVVVoid editorlogic(KeyPoll& key, Graphics& dwgfx, Game& game, entityclass& obj,  musicclass& music, mapclass& map, UtilityClass& help);

VVVVVVoid editorinput(KeyPoll& key, Graphics& dwgfx, Game& game, mapclass& map,
                 entityclass& obj, UtilityClass& help, musicclass& music);

#endif /* EDITOR_H */
